// standard print statement into implied_do form 
// print *,a       where a is a array
// print *, (a(i),i=l,u,s)  is the result



#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif

#include "compilerApi.h"

#include "pass.h"
#include "ext_func.h"

extern char * mixstring;

#define NEW_DUMMY 1000

SgExpression * change_to_impdo(SgStatement *s,SgExpression *exp)
{
        SgStatement *hedr_stmt = s->getScopeForDeclare();
	SgArrayType *type = isSgArrayType(exp->type());
	SgExpression *impdo = exp->copyPtr();
	SgExpression *array = impdo;
	s->deleteAllAttribute(NEW_DUMMY);
	
	for (int i=0; i<type->dimension(); i++) {
		int dim=0;
		SgArrayRefExp *arrayref=isSgArrayRefExp(exp);
		if (arrayref) {
			int dimcounter = 0;
			for (dim=0; dim<arrayref->numberOfSubscripts(); dim++)
			{
				if ( arrayref->isScalarOnDim(dim) ) continue;
				if (dimcounter == i) break;
				dimcounter ++;
			}
			ASSERT(dimcounter == i);
		}
		else
			dim = i;
		SgExpression *lb = get_lbound_from_arrayexp(exp,dim);
		ASSERT(lb);
		lb = lb->copyPtr();
		SgExpression *ub = get_ubound_from_arrayexp(exp,dim);
		ASSERT(ub);
		ub = ub->copyPtr();
		SgExpression *st = get_stride_from_arrayexp(exp,dim);
		ASSERT(st);
		st = st->copyPtr();
		SgTripletExp *ddot = new SgTripletExp(lb,ub,st);
		
//		SgSymbol *dummy=get_temp_variable(hedr_stmt,"DM");
		SgSymbol *dummy = s->getSymbolInCurrentScope(mixstring, "I","",i);
		dummy->setType(*SgTypeInt());

		SgExpression *exprlist = new SgExpression(EXPR_LIST,impdo,NULL,NULL);
		impdo = new SgExpression(IMPLIED_DO,exprlist,ddot,dummy);
		s->addAttribute(NEW_DUMMY,dummy,sizeof(dummy) );
	}

	  // impdo assign a scalar type
	array->setType(*type->baseType());

	  // search array part in record
	if (array->variant() == RECORD_REF)
	{
		for (; array; array=array->rhs())
		{
		  if (isSgArrayType(array->lhs()->type())) break;
		}
		ASSERT(array);
		array = array->lhs();
	}

	SgArrayRefExp *newarray = new SgArrayRefExp(*array->symbol());
	if (array->variant() == ARRAY_REF) {
		SgArrayRefExp *arrayref=isSgArrayRefExp(array);
		int counter=0;
		for (int i=0; i<arrayref->numberOfSubscripts(); i++)
		{
			if ( arrayref->isScalarOnDim(i) ) 
				newarray->addSubscript(*arrayref->subscript(i));
			else {
				SgSymbol *sym = (SgSymbol *)s->attributeValue(counter,NEW_DUMMY);
				SgExpression *symexp = new SgVarRefExp(sym);
				newarray->addSubscript(*symexp);
				counter++;
			}
		}
	}
	else {
		for (int i=0; i<type->dimension(); i++)
		{
			SgSymbol *sym = (SgSymbol *)s->attributeValue(i,NEW_DUMMY);
			SgExpression *symexp = new SgVarRefExp(sym);
			newarray->addSubscript(*symexp);
		}
	}
	array->replace(*newarray);

	return impdo;
}

void impdo_ref(SgStatement *s, SgExpression *exp)
{
	SgArrayType *type = isSgArrayType(exp->type());
	if (type == NULL) return;

	switch (exp->variant()) {
        case RECORD_REF:
	case ARRAY_REF:
	case VAR_REF:
		{
		SgExpression *newimpdo=change_to_impdo(s,exp);
		if (exp != newimpdo) exp->replace(*newimpdo);
		break;
		}
	default:
		return;
	}
}

void standard_print(SgStatement *s)
{
	SgInputOutputStmt *print = (SgInputOutputStmt *)s;

	SgExprListExp * exprlist=(SgExprListExp *)print->itemList();
	if (!exprlist) return;
	for (int i=0; i<exprlist->length(); i++) {
		impdo_ref(print, exprlist->elem(i));
        }
}
